/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package IHM.Personnel;

import Metiers.*;
import java.util.Calendar;

import java.util.Date;
import java.sql.*;
import javax.swing.JOptionPane;



/**
 *
 * @author asus
 */
public class JPDirecteur extends javax.swing.JPanel {

    JFPersonnel Jp ;
    GestionPersonnel gp=new GestionPersonnel();
    GestionContrats gc=new GestionContrats();
    GestionComptePersonnel gcp=new GestionComptePersonnel();
    
    /**
     * Creates new form JPDirecteur
     */
    public JPDirecteur() {
        initComponents();
    }
    
    public JPDirecteur (JFPersonnel Jp)
    {
        this.Jp = Jp ;
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        txtcin = new javax.swing.JTextField();
        txtprenom = new javax.swing.JTextField();
        txtsalaire = new javax.swing.JTextField();
        txtnom = new javax.swing.JTextField();
        txtemail = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        cbcontrat = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        cbxsexe = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jdatenaissance = new com.toedter.calendar.JDateChooser();
        jLabel4 = new javax.swing.JLabel();
        txtdescription = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        btnajouter = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        txtadresse = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        cbrole = new javax.swing.JComboBox<>();
        jdatedebut = new com.toedter.calendar.JDateChooser();
        txttelephone = new javax.swing.JTextField();
        jdatefin = new com.toedter.calendar.JDateChooser();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        txtcodepostal = new javax.swing.JTextField();

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1075, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 609, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("tab2", jPanel2);

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        txtcin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtcinActionPerformed(evt);
            }
        });
        jPanel1.add(txtcin, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 59, 206, -1));
        jPanel1.add(txtprenom, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 164, 206, -1));
        jPanel1.add(txtsalaire, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 310, 193, -1));
        jPanel1.add(txtnom, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 114, 206, -1));
        jPanel1.add(txtemail, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 225, 206, -1));

        jLabel1.setText("CIN");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 62, -1, -1));

        cbcontrat.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "CDD", "CDI", "CTT" }));
        cbcontrat.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbcontratItemStateChanged(evt);
            }
        });
        cbcontrat.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                cbcontratPropertyChange(evt);
            }
        });
        jPanel1.add(cbcontrat, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 380, 193, -1));

        jLabel2.setText("Nom");
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 114, 36, 22));

        cbxsexe.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "H", "F" }));
        jPanel1.add(cbxsexe, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 361, 206, -1));

        jLabel3.setText("Prenom");
        jPanel1.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 164, 54, 22));

        jLabel13.setText("Type Contrat");
        jPanel1.add(jLabel13, new org.netbeans.lib.awtextra.AbsoluteConstraints(650, 390, -1, -1));
        jPanel1.add(jdatenaissance, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 291, 206, -1));

        jLabel4.setText("Email");
        jPanel1.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 228, -1, -1));

        txtdescription.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtdescriptionActionPerformed(evt);
            }
        });
        jPanel1.add(txtdescription, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 460, 193, 59));

        jLabel5.setText("Date Naissance ");
        jPanel1.add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 291, -1, -1));

        btnajouter.setText("Ajouter ");
        btnajouter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnajouterActionPerformed(evt);
            }
        });
        jPanel1.add(btnajouter, new org.netbeans.lib.awtextra.AbsoluteConstraints(480, 550, 208, -1));

        jLabel6.setText("Sexe");
        jPanel1.add(jLabel6, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 364, -1, -1));

        jLabel7.setText("Telephone");
        jPanel1.add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 417, -1, -1));
        jPanel1.add(txtadresse, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 476, 206, -1));

        jLabel14.setText("Description");
        jPanel1.add(jLabel14, new org.netbeans.lib.awtextra.AbsoluteConstraints(660, 470, -1, -1));

        cbrole.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Gerant", "Receptionniste", "autres" }));
        jPanel1.add(cbrole, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 230, 193, -1));
        jPanel1.add(jdatedebut, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 60, 193, -1));
        jPanel1.add(txttelephone, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 417, 206, -1));
        jPanel1.add(jdatefin, new org.netbeans.lib.awtextra.AbsoluteConstraints(790, 140, 193, -1));

        jLabel8.setText("Adresse");
        jPanel1.add(jLabel8, new org.netbeans.lib.awtextra.AbsoluteConstraints(127, 479, -1, -1));

        jLabel9.setText("Date fin");
        jPanel1.add(jLabel9, new org.netbeans.lib.awtextra.AbsoluteConstraints(660, 140, -1, -1));

        jLabel10.setText("Date debut");
        jPanel1.add(jLabel10, new org.netbeans.lib.awtextra.AbsoluteConstraints(660, 60, -1, -1));

        jLabel11.setText("Role ");
        jPanel1.add(jLabel11, new org.netbeans.lib.awtextra.AbsoluteConstraints(660, 230, -1, -1));

        jLabel12.setText("Salaire");
        jPanel1.add(jLabel12, new org.netbeans.lib.awtextra.AbsoluteConstraints(660, 320, 60, -1));

        jLabel15.setText("code postal");
        jPanel1.add(jLabel15, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 530, -1, -1));
        jPanel1.add(txtcodepostal, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 530, 210, -1));

        jTabbedPane1.addTab("Ajouter Employé", jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void txtcinActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtcinActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtcinActionPerformed

    private void txtdescriptionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtdescriptionActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtdescriptionActionPerformed

    private void btnajouterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnajouterActionPerformed
          
        String cin=this.txtcin.getText();
        String nom =this.txtnom.getText();
        String prenom=this.txtprenom.getText();
        String telephone = this.txttelephone.getText();
        String email=this.txtemail.getText();
        Date datenaissance = this.jdatenaissance.getDate();
        String Sexe=this.cbxsexe.getSelectedItem().toString();
        String adresse=this.txtadresse.getText();
        int codepostal=Integer.parseInt(this.txtcodepostal.getText());
        
        
        /* contrat */
        Date datedebut=this.jdatedebut.getDate();
        Date datefin=this.jdatefin.getDate();
        Date date= new java.sql.Date(Calendar.getInstance().getTime().getTime());
        
   
        String role=this.cbrole.getSelectedItem().toString();
        float salaire=Float.parseFloat(this.txtsalaire.getText());
        String typec=this.cbcontrat.getSelectedItem().toString();
        String description = this.txtdescription.getText();
          String login = nom+"_"+prenom;
         String password =cin;
         
           if(typec.equalsIgnoreCase("CDI"))
         {
              Calendar cal = Calendar.getInstance();
              cal.set(2100, 1, 1);
             datefin=new java.sql.Date(cal.getTime().getTime());
           
           
         } 
           if(datefin.before(datedebut) || datedebut.before(date) ){
            
                
               JOptionPane.showMessageDialog(null, " la date fin ou la date debut non valide ");
               return ;
           
            
        }
           
         if(role.equalsIgnoreCase("gerant"))
         {
             this.gp.ajouterGerant(cin, nom, prenom, datenaissance, email, telephone, Sexe, adresse,codepostal);
             this.gcp.ajouter_Compte(login, cin, password, role);
             
           
         }
         else if(role.equalsIgnoreCase("receptionniste"))
         {
             this.gp.ajouterReceptioniste(cin, nom, prenom, datenaissance, email, telephone, Sexe, adresse, codepostal);
             this.gcp.ajouter_Compte(login, cin, password, role);
            
         }
           else if(role.equalsIgnoreCase("autres"))
         {
             this.gp.ajouterEmploye(cin, nom, prenom, datenaissance, email, telephone, Sexe, adresse, codepostal);
             this.gcp.ajouter_Compte(login, cin, password, role);
             this.gcp.Desactiver_Compte(cin);
            
         }
         
       
            this.gc.AjouteContrat(cin,"B456445", datefin, datedebut, typec, role, salaire, description);
        
    
      
        
        

            // TODO add your handling code here:
    }//GEN-LAST:event_btnajouterActionPerformed

    private void cbcontratPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_cbcontratPropertyChange

//        if(this.cbcontrat.getSelectedItem().toString().equalsIgnoreCase("CDI"))
//        {
//            this.jdatefin.setEnabled(false);
//        }
//        else 
//        {
//            this.jdatefin.setEnabled(true);
//            
//        }
                // TODO add your handling code here:
    }//GEN-LAST:event_cbcontratPropertyChange

    private void cbcontratItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbcontratItemStateChanged
        // TODO add your handling code here:
        if(this.cbcontrat.getSelectedItem().toString().equalsIgnoreCase("CDI"))
        {
            this.jdatefin.setEnabled(false);
        }
        else 
        {
            this.jdatefin.setEnabled(true);
            
        }
    }//GEN-LAST:event_cbcontratItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnajouter;
    private javax.swing.JComboBox<String> cbcontrat;
    private javax.swing.JComboBox<String> cbrole;
    private javax.swing.JComboBox<String> cbxsexe;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private com.toedter.calendar.JDateChooser jdatedebut;
    private com.toedter.calendar.JDateChooser jdatefin;
    private com.toedter.calendar.JDateChooser jdatenaissance;
    private javax.swing.JTextField txtadresse;
    private javax.swing.JTextField txtcin;
    private javax.swing.JTextField txtcodepostal;
    private javax.swing.JTextField txtdescription;
    private javax.swing.JTextField txtemail;
    private javax.swing.JTextField txtnom;
    private javax.swing.JTextField txtprenom;
    private javax.swing.JTextField txtsalaire;
    private javax.swing.JTextField txttelephone;
    // End of variables declaration//GEN-END:variables
}
